
%global meadversion 10.1.8
%global namedversion 10.1.8.redhat-00014
%global meadalpha .redhat_00014
%global meadrel .1
%global serial 7
%global namedversionrel redhat-00014

%bcond_without mead
%bcond_without zips

%{?scl:%global nfsmountable 1}
%{?scl:%scl_package tomcat}
%{!?scl:%global pkg_name %{name}}

%define servletspec 6.0
%define jspspec 3.1
%define elspec 5.0
%define tcuid 53
%define ecjrev 4.26.0.redhat-00002
# We need to update the pom.xml file in tomcat's gerrit repo whenever we update ecj's build version
%define jmigration 1.0.6.redhat-00003
%define cdaemon 1.3.3

# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/2.3/
%define basedir %{_localstatedir}/lib/%{pkg_name}
%define appdir %{basedir}/webapps
%define homedir %{_datadir}/%{pkg_name}
%define bindir %{homedir}/bin
%define confdir %{_sysconfdir}/%{pkg_name}
%define libdir %{_javadir}/%{pkg_name}
%define logdir %{_localstatedir}/log/%{pkg_name}
%define cachedir %{_localstatedir}/cache/%{pkg_name}
%define tempdir %{cachedir}/temp
%define workdir %{cachedir}/work
#%define _initrddir %{_sysconfdir}/rc.d/init.d
%define javasigneddir %{_datadir}/java-signed

# We need to overwrite the _file_context_* macros because they expand with the SCL prefix which results in bad file paths
%define _file_context_file %{_root_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts
%define _file_context_file_pre %{_root_sysconfdir}/selinux/${SELINUXTYPE}/contexts/files/file_contexts.pre

%define maven_version 10.1.8.redhat-00014

Name:            %{?scl_prefix}tomcat
Version:         %{meadversion}
Release:         %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:           0
Summary:         Apache Servlet/JSP Engine, RI for Servlet %{servletspec}/JSP %{jspspec} API
Group:           Networking/Daemons

%if %with mead
Source102: tomcat-bootstrap-10.1.8.redhat-00014-sources.jar
Source103: tomcat-jni-10.1.8.redhat-00014.pom
Source104: tomcat-i18n-fr-10.1.8.redhat-00014.jar
Source105: tomcat-util-scan-10.1.8.redhat-00014.jar
Source106: tomcat-servlet-api-10.1.8.redhat-00014.pom
Source107: tomcat-annotations-api-10.1.8.redhat-00014.pom
Source108: tomcat-bootstrap-10.1.8.redhat-00014.pom
Source109: tomcat-websocket-api-10.1.8.redhat-00014-sources.jar
Source110: tomcat-websocket-10.1.8.redhat-00014.pom
Source111: tomcat-jaspic-api-10.1.8.redhat-00014.pom
Source112: tomcat-embed-el-10.1.8.redhat-00014.pom
Source113: tomcat-i18n-es-10.1.8.redhat-00014.pom
Source114: tomcat-tribes-10.1.8.redhat-00014.pom
Source115: tomcat-jdbc-10.1.8.redhat-00014-sources.jar
Source116: tomcat-el-api-10.1.8.redhat-00014-sources.jar
Source117: tomcat-storeconfig-10.1.8.redhat-00014.pom
Source118: tomcat-api-10.1.8.redhat-00014.jar
Source119: tomcat-websocket-api-10.1.8.redhat-00014.jar
Source120: tomcat-10.1.8.redhat-00014-src.zip
Source121: tomcat-embed-core-10.1.8.redhat-00014.pom
Source122: tomcat-catalina-ant-10.1.8.redhat-00014.pom
Source123: tomcat-storeconfig-10.1.8.redhat-00014-sources.jar
Source124: tomcat-catalina-10.1.8.redhat-00014.jar
Source125: tomcat-servlet-api-10.1.8.redhat-00014.jar
Source126: tomcat-catalina-10.1.8.redhat-00014-sources.jar
Source127: tomcat-catalina-ha-10.1.8.redhat-00014.pom
Source128: tomcat-websocket-client-api-10.1.8.redhat-00014.pom
Source129: tomcat-juli-10.1.8.redhat-00014.jar
Source130: tomcat-10.1.8.redhat-00014.zip
Source131: tomcat-parent-10.1.8.redhat-00014-project-sources.tar.gz
Source132: tomcat-api-10.1.8.redhat-00014-sources.jar
Source133: tomcat-jasper-el-10.1.8.redhat-00014-sources.jar
Source134: tomcat-10.1.8.redhat-00014-docs.zip
Source135: tomcat-ssi-10.1.8.redhat-00014.jar
Source136: tomcat-websocket-client-api-10.1.8.redhat-00014.jar
Source137: tomcat-websocket-10.1.8.redhat-00014.jar
Source138: tomcat-websocket-api-10.1.8.redhat-00014.pom
Source139: tomcat-jasper-10.1.8.redhat-00014.jar
Source140: tomcat-catalina-ha-10.1.8.redhat-00014.jar
Source141: tomcat-annotations-api-10.1.8.redhat-00014.jar
Source142: tomcat-catalina-ha-10.1.8.redhat-00014-sources.jar
Source143: tomcat-dbcp-10.1.8.redhat-00014-sources.jar
Source144: tomcat-jasper-10.1.8.redhat-00014.pom
Source145: tomcat-servlet-api-10.1.8.redhat-00014-sources.jar
Source146: tomcat-embed-core-10.1.8.redhat-00014-sources.jar
Source147: tomcat-embed-el-10.1.8.redhat-00014.jar
Source148: tomcat-util-scan-10.1.8.redhat-00014-sources.jar
Source149: tomcat-10.1.8.redhat-00014-examples.zip
Source150: tomcat-embed-jasper-10.1.8.redhat-00014.pom
Source151: tomcat-el-api-10.1.8.redhat-00014.jar
Source152: tomcat-coyote-10.1.8.redhat-00014-sources.jar
Source153: tomcat-juli-10.1.8.redhat-00014.pom
Source154: tomcat-jdbc-10.1.8.redhat-00014.pom
Source155: tomcat-juli-10.1.8.redhat-00014-sources.jar
Source156: tomcat-dbcp-10.1.8.redhat-00014.pom
Source157: tomcat-embed-websocket-10.1.8.redhat-00014.pom
Source158: tomcat-api-10.1.8.redhat-00014.pom
Source159: tomcat-jaspic-api-10.1.8.redhat-00014.jar
Source160: tomcat-bootstrap-10.1.8.redhat-00014.jar
Source161: tomcat-embed-el-10.1.8.redhat-00014-sources.jar
Source162: tomcat-embed-websocket-10.1.8.redhat-00014.jar
Source163: tomcat-jasper-el-10.1.8.redhat-00014.jar
Source164: tomcat-tribes-10.1.8.redhat-00014.jar
Source165: tomcat-tribes-10.1.8.redhat-00014-sources.jar
Source166: tomcat-util-10.1.8.redhat-00014.jar
Source167: tomcat-jsp-api-10.1.8.redhat-00014.jar
Source168: tomcat-i18n-fr-10.1.8.redhat-00014.pom
Source169: tomcat-embed-jasper-10.1.8.redhat-00014.jar
Source170: tomcat-embed-websocket-10.1.8.redhat-00014-sources.jar
Source171: tomcat-dbcp-10.1.8.redhat-00014.jar
Source172: tomcat-10.1.8.redhat-00014.pom
Source173: tomcat-el-api-10.1.8.redhat-00014.pom
Source174: tomcat-parent-10.1.8.redhat-00014.pom
Source175: tomcat-ssi-10.1.8.redhat-00014.pom
Source176: tomcat-jsp-api-10.1.8.redhat-00014-sources.jar
Source177: tomcat-catalina-ant-10.1.8.redhat-00014-sources.jar
Source178: tomcat-annotations-api-10.1.8.redhat-00014-sources.jar
Source179: tomcat-jaspic-api-10.1.8.redhat-00014-sources.jar
Source180: tomcat-catalina-10.1.8.redhat-00014.pom
Source181: tomcat-i18n-ja-10.1.8.redhat-00014.pom
Source182: tomcat-catalina-ant-10.1.8.redhat-00014.jar
Source183: tomcat-embed-jasper-10.1.8.redhat-00014-sources.jar
Source184: tomcat-storeconfig-10.1.8.redhat-00014.jar
Source185: tomcat-jni-10.1.8.redhat-00014-sources.jar
Source186: tomcat-jasper-el-10.1.8.redhat-00014.pom
Source187: tomcat-coyote-10.1.8.redhat-00014.jar
Source188: tomcat-ssi-10.1.8.redhat-00014-sources.jar
Source189: tomcat-i18n-es-10.1.8.redhat-00014.jar
Source190: tomcat-embed-core-10.1.8.redhat-00014.jar
Source191: tomcat-jni-10.1.8.redhat-00014.jar
Source192: tomcat-websocket-10.1.8.redhat-00014-sources.jar
Source193: tomcat-i18n-ja-10.1.8.redhat-00014.jar
Source194: tomcat-util-scan-10.1.8.redhat-00014.pom
Source195: tomcat-jsp-api-10.1.8.redhat-00014.pom
Source196: tomcat-coyote-10.1.8.redhat-00014.pom
Source197: tomcat-jasper-10.1.8.redhat-00014-sources.jar
Source198: tomcat-util-10.1.8.redhat-00014.pom
Source199: tomcat-websocket-client-api-10.1.8.redhat-00014-sources.jar
Source200: tomcat-jdbc-10.1.8.redhat-00014.jar
Source201: tomcat-util-10.1.8.redhat-00014-sources.jar
%endif

License:         ASL 2.0
URL:             http://tomcat.apache.org/
BuildArch:       noarch
BuildRoot:       %{_tmppath}/%{pkg_name}-%{version}-%{release}-root

Source6:         %{pkg_name}-digest.sh
Source7:         %{pkg_name}-tool-wrapper.sh
# for SELinux
Source12:        %{pkg_name}.if

Source1:         %{pkg_name}.el8.conf
Source3:         %{pkg_name}.el8.sysconfig
Source4:         %{pkg_name}.el8.wrapper
Source11:        %{pkg_name}.el8.te
Source13:        %{pkg_name}.el8.fc
Source17:        %{pkg_name}.service
Source18:        %{pkg_name}-functions
Source19:        %{pkg_name}-preamble
Source20:        %{pkg_name}-server
Source21:        %{pkg_name}-named.service

# The location of a JAR changed between el6 and el7,
# so there are two patches...
Patch0:          catalina-policy.patch

BuildRequires:   unzip
BuildRequires:   findutils
BuildRequires:   %{?scl_prefix}javapackages-tools

BuildRequires:   java-devel >= 0:1.7.0
# Required for _unitdir macro expansion
BuildRequires:   systemd-units

Requires(pre):   shadow-utils
Requires(pre):   shadow-utils
Requires:        (java-11-headless or java-17-headless)
Requires:        %{?scl_prefix}javapackages-tools
Requires:        procps
Requires:        %{name}-lib = %{epoch}:%{version}-%{release}
Requires(post):  chkconfig
Requires(preun): chkconfig
# Conditional for RHBZ#2012924 - redhat-lsb-core has been removed in RHEL9
%if 0%{?rhel} <= 8
Requires(post):  /lib/lsb/init-functions
Requires(preun): /lib/lsb/init-functions
%else
Requires(post):  /etc/os-release
Requires(preun): /etc/os-release
%endif
# End of conditional
Requires(post):  %{?scl_prefix}javapackages-tools
Requires(postun):%{?scl_prefix}javapackages-tools

%{?scl:Requires: %scl_runtime}

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License version 2.0. Tomcat is intended
to be a collaboration of the best-of-breed developers from around the world.

%package admin-webapps
Group:           System Environment/Applications

Summary:         The host-manager and manager web applications for Apache Tomcat
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description admin-webapps
The host-manager and manager web applications for Apache Tomcat.

%package docs-webapp
Group:           System Environment/Applications

Summary:         The docs web application for Apache Tomcat
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description docs-webapp
The docs web application for Apache Tomcat.

%package el-%{elspec}-api
Summary:         Expression Language v%{elspec} API
Group:           Development/Libraries/Java

Provides:        el_api = %{elspec}
Requires(post):  %{?scl_prefix}javapackages-tools
Requires(postun):%{?scl_prefix}javapackages-tools
Requires:        %{?scl_prefix}javapackages-tools

%description el-%{elspec}-api
Expression Language %{elspec} 

%package javadoc
Group:           Documentation

Summary:         Javadoc generated documentation for Apache Tomcat
Requires(pre):   coreutils
Requires:        %{?scl_prefix}javapackages-tools
%global __requires_exclude jpackage-utils

%description javadoc
Javadoc generated documentation for Apache Tomcat.

%package jsp-%{jspspec}-api
Group:           Internet/WWW/Dynamic Content

Summary:         Apache Tomcat JSP API implementation classes
Provides:        jsp = %{jspspec}
Requires:        %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires:        %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires(post):  %{?scl_prefix}javapackages-tools
Requires(postun):%{?scl_prefix}javapackages-tools
Requires:        %{?scl_prefix}javapackages-tools

%description jsp-%{jspspec}-api
Apache Tomcat JSP API implementation classes.

%package lib
Group:           Development/Compilers

Summary:         Libraries needed to run the Tomcat Web container
Requires:        %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires:        %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires:        %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires(post):  %{?scl_prefix}javapackages-tools
Requires(postun):%{?scl_prefix}javapackages-tools
Requires:        %{?scl_prefix}javapackages-tools
Requires(preun): coreutils

%description lib
Libraries needed to run the Tomcat Web container.

%package servlet-%{servletspec}-api
Group:           Internet/WWW/Dynamic Content

Summary:         Apache Tomcat Servlet API implementation classes
Provides:        servlet = %{servletspec}
Requires(post):  %{?scl_prefix}javapackages-tools
Requires(postun):%{?scl_prefix}javapackages-tools
Requires:        %{?scl_prefix}javapackages-tools

%description servlet-%{servletspec}-api
Apache Tomcat Servlet API implementation classes.

%package webapps
Group:           System Environment/Applications

Summary:         The ROOT web application for Apache Tomcat
Requires:        %{name} = %{epoch}:%{version}-%{release}

%description webapps
The ROOT web application for Apache Tomcat.

%if %with zips
%package zip
Summary:         Container for the zipped distribution of tomcat
Group:           Development


%description zip
Container for the zipped distribution of tomcat

%package src-zip
Summary:         Container for the sources
Group:           Development


%description src-zip
Container for the sources
%endif

%package selinux
Summary:         Selinux policy for tomcat
Group:           System Environment/Daemons

BuildRequires:   selinux-policy, selinux-policy-devel

%if "%{_selinux_policy_version}" != ""
Requires(pre):   selinux-policy-targeted >= %{_selinux_policy_version}
Requires(post):  selinux-policy-targeted >= %{_selinux_policy_version}
Requires(postun):selinux-policy-targeted >= %{_selinux_policy_version}
%endif
Requires:        %{name} = %{version}-%{release}
Requires(pre):   policycoreutils, python3-policycoreutils, libselinux-utils
Requires(post):  policycoreutils, python3-policycoreutils, libselinux-utils
Requires(postun):policycoreutils, python3-policycoreutils, libselinux-utils

%description selinux
This is the selinux policy for tomcat.

%prep
echo Prep Phase

%setup -q -c -T

# Update paths in configuration files before installing them
# This allows any changes in SCL directories to be seamlessly consumed
sed -i 's|$datadir|%{_datadir}|g; s|$sysconfdir|%{_sysconfdir}|g; s|$sbindir|%{_sbindir}|g; s|$libexecdir|%{_libexecdir}|g; s|$localstatedir|%{_localstatedir}|g' %{_sourcedir}/*

# binary distribution
unzip %{_sourcedir}/%{pkg_name}-%{namedversion}.zip
# javadocs zip
unzip -d fulldocs %{_sourcedir}/%{pkg_name}-%{namedversion}-docs.zip

# Cleanup all of the windows resources
find . -type f -name "*.bat" -o -type f -name "*.pdf" | xargs -t -I{} %{__rm} {}

# Apply the policy patch to allow use of ecj jar
pushd apache-%{pkg_name}-%{namedversion}
%patch0 -p0
popd

%{__mkdir_p} selinux
%{__cp} -p %{SOURCE11} ./selinux/%{name}.te
%{__cp} -p %{SOURCE12} ./selinux/%{name}.if
%{__cp} -p %{SOURCE13} ./selinux/%{name}.fc

%build
echo Build Phase

pushd selinux
  make -f %{_root_datadir}/selinux/devel/Makefile
  # we don't want to include tmp in the doc distribution
  %{__rm} -rf tmp
popd

%install
echo Install Phase

scl enable %{scl} - <<"SCLEOF"
%{__rm} -rf $RPM_BUILD_ROOT
# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}-%{version}
%{__ln_s} %{pkg_name}-%{version} ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{bindir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/Catalina/localhost
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{logdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{tempdir}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{workdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sbindir}

%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{_localstatedir}/lib/tomcats
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_unitdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}
%{__install} -d -m 0775 ${RPM_BUILD_ROOT}%{confdir}/conf.d
/bin/echo "Place your custom *.conf files here. Shell expansion is supported." > ${RPM_BUILD_ROOT}%{confdir}/conf.d/README

# move things into place
echo Install: Copy things into place

pushd apache-%{pkg_name}-%{namedversion}
    %{__cp} -a bin/*.{jar,xml} ${RPM_BUILD_ROOT}%{bindir}
    %{__cp} -a conf/*.{policy,properties,xml,xsd} ${RPM_BUILD_ROOT}%{confdir}
    %{__cp} -a lib/*.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd

# javadoc
pushd fulldocs/apache-%{pkg_name}-%{namedversion}/webapps/
    %{__cp} -a docs/api/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{pkg_name}-%{version}
popd

%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE1} \
    > ${RPM_BUILD_ROOT}%{confdir}/%{pkg_name}.conf
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE3} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{pkg_name}
%{__install} -m 0755 %{SOURCE4} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{pkg_name}
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE6} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{pkg_name}-digest
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE7} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{pkg_name}-tool-wrapper

%{__install} -m 0644 %{SOURCE17} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}.service
%{__install} -m 0644 %{SOURCE18} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/functions
%{__install} -m 0755 %{SOURCE19} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/preamble
%{__install} -m 0755 %{SOURCE20} \
    ${RPM_BUILD_ROOT}%{_libexecdir}/%{pkg_name}/server
%{__install} -m 0644 %{SOURCE21} \
    ${RPM_BUILD_ROOT}%{_unitdir}/%{name}@.service

pushd ${RPM_BUILD_ROOT}%{libdir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
	if [[ "$j" != *"ecj"* ]] && [[ "$j" != *"jakartaee-migration"* ]]; then
            %{__ln_s} ${j}.jar ${j}-%{version}.jar 
	fi
    done
popd

pushd ${RPM_BUILD_ROOT}%{_javadir}
    # symlink to maven components
    echo "Link maven components"
    #tomcat-jsp-api
    %{__ln_s} %{pkg_name}/jsp-api-%{version}.jar \
        %{pkg_name}-jsp-%{jspspec}-api-%{version}.jar
    # tomcat-servlet-api
    %{__ln_s} %{pkg_name}/servlet-api-%{version}.jar \
        %{pkg_name}-servlet-%{servletspec}-api-%{version}.jar
    # tomcat-el-api
    %{__ln_s} %{pkg_name}/el-api-%{version}.jar \
        %{pkg_name}-el-%{elspec}-api-%{version}.jar

    # extra links to satisfy what's defined for rpms
    %{__ln_s} %{pkg_name}-jsp-%{jspspec}-api-%{version}.jar %{pkg_name}-jsp-%{jspspec}-api.jar
    %{__ln_s} %{pkg_name}-servlet-%{servletspec}-api-%{version}.jar %{pkg_name}-servlet-%{servletspec}-api.jar
    %{__ln_s} %{pkg_name}-el-%{elspec}-api-%{version}.jar %{pkg_name}-el-%{elspec}-api.jar
popd

pushd ${RPM_BUILD_ROOT}%{bindir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
	if [ "${j}" == "commons-daemon" ]; then
	    %{__mv} ${j}.jar ${j}-%{cdaemon}.jar
            %{__ln_s} ${j}-%{cdaemon}.jar ${j}.jar
	else
            %{__mv} ${j}.jar ${j}-%{version}.jar
            %{__ln_s} ${j}-%{version}.jar ${j}.jar
	fi
    done
popd

# symlink to the FHS locations where we've installed things
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{confdir} conf
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
    %{__ln_s} %{tempdir} temp
    %{__ln_s} %{workdir} work
popd

%if %with zips
echo Zips
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev
# Copy over source zip for the src-zip subpackage
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-src.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-src.zip
# Copy over zip for the zip subpackage
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-docs.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-docs.zip
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}-examples.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-examples.zip
%{__install} -p -m 0644 %{_sourcedir}/%{pkg_name}-%{namedversion}.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}.zip
echo End Zips
%endif

install -d $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}
install -p -m 644 selinux/%{name}.pp $RPM_BUILD_ROOT/%{_datadir}/selinux/packages/%{name}/%{name}.pp

# End scl usage
SCLEOF

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add the tomcat user and group
getent group tomcat >/dev/null || %{_root_sbindir}/groupadd -f -g %{tcuid} -r tomcat
if ! getent passwd tomcat >/dev/null ; then
    if ! getent passwd %{tcuid} >/dev/null ; then
        %{_root_sbindir}/useradd -r -u %{tcuid} -g tomcat -d %{homedir} -s /sbin/nologin -c "Apache Tomcat" tomcat
        # Tomcat uses a reserved ID, so there should never be an else
    fi
fi
exit 0

%post
# install but don't activate
%systemd_post %{name}.service

%pre javadoc
%{__rm} -rf %{_javadocdir}/%{pkg_name}

%preun
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*

# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*
%systemd_preun %{name}.service

%systemd_postun_with_restart %{name}.service

%pre selinux
# The %%selinux_relabel_pre macro expands incorrectly with SCL on el7
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi
if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    [ -f %{_file_context_file_pre} ] || cp -f %{_file_context_file} %{_file_context_file_pre}
fi

%post selinux
# The following macros expand incorrectly with SCL on el7
# %%selinux_modules_install %%{_datadir}/selinux/packages/%%{name}/%%{name}.pp
# %%selinux_relabel_post
. /etc/selinux/config
_policytype=
if [ -z "${_policytype}" ]; then
  _policytype="targeted"
fi

%{_root_sbindir}/semodule -n -s ${_policytype} -X 200 -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 

if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
    %{_root_sbindir}/load_policy
    if [ -f %{_file_context_file_pre} ]; then
        /sbin/fixfiles -C %{_file_context_file_pre} restore
        rm -f %{_file_context_file_pre}
    fi
fi

%postun selinux
# The following macros expand incorrectly with SCL on el7
# %%selinux_modules_uninstall %{name}
# %%selinux_relabel_post
if [ $1 -eq 0 ]; then
    . /etc/selinux/config
    _policytype=
    if [ -z "${_policytype}" ]; then
      _policytype="targeted"
    fi

    /usr/sbin/semodule -n -X 200 -r %{name} &> /dev/null || :
    if %{_root_sbindir}/selinuxenabled && [ "${SELINUXTYPE}" = "${_policytype}" ]; then
       %{_root_sbindir}/load_policy
       if [ -f %{_file_context_file_pre} ]; then
         /sbin/fixfiles -C %{_file_context_file_pre} restore
         rm -f %{_file_context_file_pre}
       fi
    fi
fi

%files
%defattr(0640,root,root,0750)
%attr(0755,root,root) %{_bindir}/%{pkg_name}-digest
%attr(0755,root,root) %{_bindir}/%{pkg_name}-tool-wrapper
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/%{pkg_name}

%defattr(0640,root,tomcat,0750)
%dir %{basedir}
%attr(0751,root,tomcat) %dir %{homedir}
%dir %{confdir}
%attr(0770,root,tomcat) %dir %{confdir}/Catalina
%attr(0770,root,tomcat) %dir %{confdir}/Catalina/localhost
%dir %{confdir}/conf.d
%{confdir}/conf.d/README
%config(noreplace) %{confdir}/%{pkg_name}.conf
%config(noreplace) %{confdir}/catalina.policy
%config(noreplace) %{confdir}/catalina.properties
%config(noreplace) %{confdir}/logging.properties
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/tomcat-users.xml
%{confdir}/tomcat-users.xsd
%config(noreplace) %{confdir}/jaspic-providers.xml
%{confdir}/jaspic-providers.xsd
%config(noreplace) %{confdir}/web.xml
# Tomcat needs to write to all of these dirs
%attr(0770,tomcat,tomcat) %dir %{cachedir}
%attr(0770,tomcat,tomcat) %dir %{tempdir}
%attr(0770,tomcat,tomcat) %dir %{workdir}
%attr(0770,tomcat,tomcat) %dir %{appdir}
# Slightly more restrictive group access (-w) on the logs
%attr(0750,tomcat,tomcat) %dir %{logdir}

%defattr(0644,root,root,0755)
%dir %{bindir}
%{bindir}/bootstrap-%{version}.jar
%{bindir}/bootstrap.jar
%{bindir}/catalina-tasks.xml
%{bindir}/tomcat-juli-%{version}.jar
%{bindir}/tomcat-juli.jar
%{bindir}/commons-daemon-%{cdaemon}.jar
%{bindir}/commons-daemon.jar

%defattr(0640,root,root,0750)
%{homedir}/conf
%{homedir}/lib
%{homedir}/logs
%{homedir}/temp
%{homedir}/webapps
%{homedir}/work

%defattr(0755,root,root,0755)
%{_sbindir}/%{pkg_name}
%attr(0644,root,root) %{_unitdir}/%{name}.service
%attr(0644,root,root) %{_unitdir}/%{name}@.service
%dir %{_libexecdir}/%{pkg_name}
%dir %{_localstatedir}/lib/tomcats
%{_libexecdir}/%{pkg_name}/functions
%{_libexecdir}/%{pkg_name}/preamble
%{_libexecdir}/%{pkg_name}/server

%files webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/ROOT

%files admin-webapps
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/host-manager
%{appdir}/manager
%config(noreplace) %{appdir}/manager/WEB-INF/web.xml
%config(noreplace) %{appdir}/manager/META-INF/context.xml
%config(noreplace) %{appdir}/host-manager/WEB-INF/web.xml
%config(noreplace) %{appdir}/host-manager/META-INF/context.xml

%files docs-webapp
%defattr(0640,tomcat,tomcat,0750)
%{appdir}/docs

%files el-%{elspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{pkg_name}-el-%{elspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-el-%{elspec}-api.jar
%dir %{libdir}
%{libdir}/el-api.jar
%{libdir}/el-api-%{version}.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{pkg_name}-%{version}
%{_javadocdir}/%{pkg_name}

%files jsp-%{jspspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{pkg_name}-jsp-%{jspspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-jsp-%{jspspec}-api.jar
%dir %{libdir}
%{libdir}/jsp-api.jar
%{libdir}/jsp-api-%{version}.jar

%files lib
%defattr(0644,root,root,0755)
%dir %{libdir}
%{libdir}/annotations-api.jar
%{libdir}/annotations-api-%{version}.jar
%{libdir}/catalina.jar
%{libdir}/catalina-%{version}.jar
%{libdir}/catalina-ant.jar
%{libdir}/catalina-ant-%{version}.jar
%{libdir}/catalina-ha.jar
%{libdir}/catalina-ha-%{version}.jar
%{libdir}/catalina-tribes.jar
%{libdir}/catalina-tribes-%{version}.jar
%{libdir}/catalina-ssi.jar
%{libdir}/catalina-ssi-%{version}.jar
%{libdir}/catalina-storeconfig.jar
%{libdir}/catalina-storeconfig-%{version}.jar
%{libdir}/tomcat-jdbc.jar
%{libdir}/tomcat-jdbc-%{version}.jar
%{libdir}/tomcat-util.jar
%{libdir}/tomcat-util-%{version}.jar
%{libdir}/tomcat-api.jar
%{libdir}/tomcat-api-%{version}.jar
%{libdir}/ecj-%{ecjrev}.jar
%{libdir}/jakartaee-migration-%{jmigration}-shaded.jar
%{libdir}/jasper.jar
%{libdir}/jasper-%{version}.jar
%{libdir}/jasper-el.jar
%{libdir}/jasper-el-%{version}.jar
%{libdir}/jaspic-api.jar
%{libdir}/jaspic-api-%{version}.jar
%{libdir}/tomcat-api.jar
%{libdir}/tomcat-api-%{version}.jar
%{libdir}/tomcat-coyote.jar
%{libdir}/tomcat-coyote-%{version}.jar
%{libdir}/tomcat-dbcp.jar
%{libdir}/tomcat-dbcp-%{version}.jar
%{libdir}/tomcat-i18n-*.jar
%{libdir}/tomcat-jdbc.jar
%{libdir}/tomcat-jdbc-%{version}.jar
%{libdir}/tomcat-jni.jar
%{libdir}/tomcat-jni-%{version}.jar
%{libdir}/tomcat-util-scan.jar
%{libdir}/tomcat-util-scan-%{version}.jar
%{libdir}/tomcat-util.jar
%{libdir}/tomcat-util-%{version}.jar
%{libdir}/tomcat-websocket.jar
%{libdir}/tomcat-websocket-%{version}.jar
%{libdir}/websocket-api.jar
%{libdir}/websocket-api-%{version}.jar
%{libdir}/websocket-client-api.jar
%{libdir}/websocket-client-api-%{version}.jar

%files servlet-%{servletspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{pkg_name}-servlet-%{servletspec}-api-%{version}.jar
%{_javadir}/%{pkg_name}-servlet-%{servletspec}-api.jar
%dir %{libdir}
%{libdir}/servlet-api.jar
%{libdir}/servlet-api-%{version}.jar

%if %with zips
%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{pkg_name}-fordev
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-docs.zip
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-examples.zip
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}.zip

%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{pkg_name}-fordev
%{_javadir}/%{pkg_name}-fordev/tomcat-%{namedversion}-src.zip
%endif

%files selinux
%defattr(-,root,root,-)
%dir %{_datadir}/selinux
%dir %{_datadir}/selinux/packages
%dir %{_datadir}/selinux/packages/%{name}
%{_datadir}/selinux/packages/%{name}/%{name}.pp
%doc selinux/*

%changelog
* Fri Apr 05 2024 Sokratis Zappis <szappis@redhat.com> - 10.1.8-7.redhat_00014.1
- Resolves: [JWS-3223] - CVE-2024-23672 tomcat: Apache Tomcat: WebSocket DoS with incomplete closing handshake
- Build for 6.0.2.CR1

* Tue Aug 22 2023 Sokratis Zappis <szappis@redhat.com> - 10.1.8-2.redhat_00007.1
- Resolves: JWS-3031 Some RPMs contain unnecessary obsoletes

* Thu Jun 08 2023 Sokratis Zappis <szappis@redhat.com> - 10.1.8-3.redhat_00002.1
- Resolves: JWS-2960 Remove Java 8 requirement from RPMs
- Clean up some conditionals for RHEL7 since we don't build for that OS anymore
- Remove subpackage introduced by hack for JWS-1708

* Thu Apr 27 2023 Hui Wang <huwang@redhat.com> - 10.1.8-1.redhat_00001.1
- Update to 10.1.8
- Remove RHEL6 stuff

* Tue Mar 07 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-11.redhat_00008.1
- 5.7.2.CR1

* Tue Feb 21 2023 Sokratis Zappis <szappis@redhat.com> - 9.0.62-10.redhat_00007.1
- 5.7.2.DR1

* Tue Oct 18 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-9.redhat_00005.1
- Supplemental fix for JWS-2618 avoid xorg dependency through java package in JWS rpms

* Fri Sep 23 2022 Hui Wang <huwang@redhat.com> - 9.0.62-7.redhat_00004.1
- Resolves: JWS-2618 avoid xorg dependency through java package in JWS rpms

* Thu Aug 25 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-6.redhat_00003.1
- Resolves: JWS-1467 Upgrade ECJ to latest available version

* Tue Jul 26 2022 Sokratis Zappis <szappis@redhat.com> - 9.0.62-4.redhat_00002.1
- Adding conditional for RHEL9 build due to RHBZ#2012924

* Tue Apr 27 2021 Hui Wang <huwang@redhat.com> - 9.0.43-8.redhat_8.1
- Related: JWS-1665 clean up the unnecessary references

* Thu Mar 18 2021 Hui Wang <huwang@redhat.com> - 9.0.43-6.redhat_6.1
- Resolves: JWS-1708 JWS5 requires Java8

* Tue Mar 16 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.43-5.redhat_5.1
- Build for JWS 5.5.0.ER2

* Thu Mar 11 2021 Hui Wang <huwang@redhat.com> - 9.0.43-4.redhat_4.1
- Resolves: JWS-1708 JWS5 requires Java8

* Thu Mar 04 2021 Hui Wang <huwang@redhat.com> - 9.0.43-2.redhat_2.1
- Related: JWS-1665 bndlib is not needed

* Tue Mar 02 2021 Hui Wang <huwang@redhat.com> - 9.0.43-1.redhat_1.1
- Update to 9.0.43

* Fri Jan 15 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.36-9.redhat_8.1
- Rebuilding

* Thu Jan 14 2021 Sokratis Zappis <szappis@redhat.com> - 9.0.36-8.redhat_7.1
- Rebuilding

* Thu Jan 14 2021 Hui Wang <huwang@redhat.com> - 9.0.36-7.redhat_6.1
- Resolves: JWS-1858 CVE-2020-13943 tomcat: Apache Tomcat HTTP/2 Request mix-up [jws-5]
- Resolves: JWS-1894 CVE-2020-17527 tomcat: HTTP/2 request header mix-up [jws-5]

* Tue Sep 15 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.36-6.redhat_5.2
- Resolves: JWS-1739 unable to make tomcat9/jws5 FIPS-compliant with NSS

* Tue Sep 15 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.36-5.redhat_5.1
- Resolves: JWS-1739 unable to make tomcat9/jws5 FIPS-compliant with NSS

* Fri Sep 11 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-4.redhat_4.1
- Resolves: JWS-1828 o.a.c.valves.HealthCheckValve returns 404 incorrectly

* Tue Sep 08 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-3.redhat_3.1
- Update sources

* Fri Jul 17 2020 Hui Wang <huwang@redhat.com> - 9.0.36-2.redhat_2.1
- Resolves: JWS-1750 CVE-2020-13934 tomcat: OutOfMemoryException caused by HTTP/2 connection leak could lead to DoS [jws-5.4] 
- Resolves: JWS-1751 CVE-2020-13935 tomcat: multiple requests with invalid payload length in a WebSocket frame could lead to DoS [jws-5.4]

* Thu Jun 25 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.36-1.redhat_1.1
- Rebuild

* Tue Mar 31 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.30-3.redhat_4.1
- 5.3.0.CR1
- Resolves: JWS-1592 Missing jar file in maven repository
- Resolves: JWS-1598 Storing configuration fails with java.lang.NoSuchMethodException

* Tue Mar 10 2020 Sokratis Zappis <szappis@redhat.com> - 9.0.30-2.redhat_3.1
- 5.3.0.ER1

* Tue Feb 25 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.30-2.redhat_3.1
- Related: JWS-1585 Refactor secret check
- Resolves: Add missing changelog entries

* Tue Feb 11 2020 Coty Sutherland <csutherl@redhat.com> - 9.0.30-1.redhat_2.1
- 5.3.0.DR1
- Remove jbcs-httpd24-javapackages-tools BuildRequires
- Resolves: JWS-1468 Rebase Tomcat to version 9.0.30
- Resolves: JWS-1478 rpm install/update overwrites context.xml for host-manager and manager applications
- Resolves: JWS-1500 CVE-2019-12418 tomcat: local privilege escalation
- Resolves: JWS-1502 CVE-2019-17563 tomcat: session fixation
- Resolves: JWS-1419 java-headless requirement forces OpenJDK install
- Resolves: JWS-1589 CVE-2019-17569 tomcat: Regression in handling of Transfer-Encoding header allows for HTTP request smuggling
- Resolves: JWS-1587 CVE-2020-1935 tomcat: Mishandling of Transfer-Encoding header allows for HTTP request smuggling
- Resolves: JWS-1585 CVE-2020-1938 ajp: tomcat: Apache Tomcat AJP File Read/Inclusion Vulnerability

* Wed Oct 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-10.redhat_4.1
- 5.2.0.ER2
- Related: JWS-1430 Correct conf changes

* Thu Aug 29 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-9.redhat_3.2
- 5.2.0.DR2

* Fri Aug 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-7.redhat_2.1
- Resolves: JWS-1435 Drop jsvc support
- Resolves: JWS-1430 RPM shutdown throws warnings with Java 11

* Fri Aug 02 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-6.redhat_2.1
- Rebuild tomcat to include new ECJ version and remove commons-daemon

* Tue Jul 16 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-5.redhat_1.1
- 5.2.0.DR1
- Resolves: JWS-1426 Remove broken alternatives post-install scriptlets on RHEL 8
- Resolves: JWS-1417 CVE-2019-10072 tomcat: HTTP/2 implementation leads to denial of service
- Resolves: JWS-1367 CVE-2019-0232 tomcat: Remote Code Execution on Windows
- Resolves: JWS-1402 CVE-2019-0221 tomcat: XSS in SSI printenv
- Resolves: JWS-1318 CVE-2019-0199 tomcat: Apache Tomcat HTTP/2 DoS

* Mon Jul 15 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-4.redhat_1.1
- More selinux fixes

* Fri Jul 12 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-3.redhat_1.1
- Updates to selinux policy

* Thu Jul 11 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-2.redhat_1.1
- 5.2.0.DR1, selinux changes

* Mon Jun 17 2019 Coty Sutherland <csutherl@redhat.com> - 9.0.21-1.redhat_1.1
- Cleanup some outdated information in spec subpackages
- Resolves: JWS-1361 SELinux policy enhancements and fixes

* Fri Apr 05 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_17.1
- Rebuild
- Related: JWS-1341 Remove commons-daemon.jar until it is removed from the tomcat zip and package logrotate in rhel-6 only

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Correcting catalina-policy.patch format

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Remove commons-daemon dependency

* Thu Apr 04 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-20.redhat_16.1
- Resolves: JWS-1341

* Thu Mar 14 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-19.redhat_16.1
- JWS-1332 attempt 2

* Wed Mar 13 2019 Sokratis Zappis <szappis@redhat.com> - 9.0.7-18.redhat_16.1
- Resolves: JWS-1332

* Thu Nov 29 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-17.redhat_16.1
- Build with dynamic suffix, attempt two

* Thu Nov 29 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-17.redhat_16.1
- Resolves: JWS-1290 Several pom.xml files are invalid according to Maven POM XSD

* Mon Nov 26 2018 Georgios Zaronikas- Karagiannis <gzaronik@redhat.com> - 9.0.7-16.redhat_15.1
- JWS 5.0.2 ER1

* Fri Nov 09 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-15.redhat_14.1
- Bump tomcat GAV version

* Thu Nov 08 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-14.redhat_13.1
- 5.0.2.DR1, attempt 2. Disable javadocs failonwarning

* Mon Nov 05 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-14.redhat_13.1
- Resolves: JWS-1098 CVE-2018-8034 tomcat: host name verification missing in WebSocket client
- Resolves: JWS-1068 CVE-2018-8014 tomcat: Insecure defaults in CORS filter enable 'supportsCredentials' for all origins
- Resolves: JWS-1074 Use GMT in expires date format
- Resolves: JWS-1153 Body text property replacement fails
- Resolves: JWS-1072 Missing handshake timeouts for NIO 2 and NIO 2 timeout improvements
- Resolves: JWS-1080 Error page processing regression
- Resolves: JWS-1128 Improve the handling of path parameters with request dispatcher
- Resolves: JWS-1160 Tomcat Host Manager incorrectly saves connector with SSL configuration
- Resolves: JWS-1123 Better embedded support and user experience for native
- Resolves: JWS-1164 Add some substitution recursive parsing for rewrite
- Resolves: JWS-1070 Unexpected handshake failures with OpenSSL
- Resolves: JWS-1069 Avoid error pages in some cases
- Resolves: JWS-1073 NIO 2 fixes affecting IO API reliability
- Resolves: JWS-1071 Java 11 support for annotation scanning
- Resolves: JWS-1018 Relax Host validation by removing the requirement that the final component of a FQDN must be alphabetic

* Wed Oct 10 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-13.redhat_12.1
- Resolves: JWS-1159 Update %%{_sysconfdir} and %%{_localstatedir} in RPM configuration files
- Resolves: JWS-1158 Update reference to java-functions

* Fri Sep 07 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-12.redhat_12.1
- Fix the redhat version suffix

* Wed Sep 05 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-11.redhat_11.1
- JWS_5.0.0.SP1_ER1
- Resolves: JWS-996 Connection leak during XATransaction in high load
- Resolves: JWS-1028 Failures in jBPM embedded use case with H2 database
- Resolves: JWS-1064 Update the Tomcat fork of Commons DBCP 2 to 2.4.0
- Resolves: JWS-1065 Tomcat Commons Pool Update
- Resolves: JWS-1121 Update the internal fork of Apache Commons DBCP 2 to abc0484 (2018-08-09) to pick up some bug fixes and enhancements
- Resolves: JWS-1124 ARJUNA016082: Synchronizations are not allowed! Transaction status isActionStatus.RUNNING when running jBPM engine in KIE server deployed to Tomcat
- Resolves: JWS-1125 CVE-2018-1336 tomcat: Improve handing of overflow in the UTF-8 decoder with supplementary characters
- Resolves: JWS-1132 CVE-2018-11784 tomcat: Avoid protocol relative redirects in default servlet
- Resolves: JWS-1099 CVE-2018-8037 tomcat: Due to a mishandling of close in NIO/NIO2 connectors user sessions can get mixed up

* Wed Jun 06 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-10.redhat_10.1
- JWS-5.0.0.RHEL_CR1
- Resolves: JWS-1024 Tomcat's Digester tries to use a non-initialized variable causing a NPE
- Resolves: JWS-996 Connection leak during XATransaction in high load

* Fri May 18 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-9.redhat_9.1
- Related: JWS-995 Tweaking maven dependencies at bit

* Tue May 15 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-8.redhat_8.1
- Building without the embed zip

* Tue May 15 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-7.redhat_7.1
- Build for JWS-5.0.0.RHEL_ER2

* Thu May 03 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-7.redhat_6.1
- Related: JWS-967 Remove jpackages-util dep from javadoc subpackage

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-6.redhat_6.1
- Rebuild to include fix for JWS-991

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-5.redhat_5.1
- Rebuild for JWS-521 and JWS-991

* Tue May 01 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-5.redhat_4.1
- Related: JWS-521 Hardcode path to commons-daemon after JWS-968 broke jsvc

* Mon Apr 16 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-4.redhat_4.1
- Resolves: JWS-972 Enable the configuration of multiple properties files
- Resolves: JWS-973 Add system property expansion support for properties files

* Thu Apr 12 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-3.redhat_2.1
- Resolves: JWS-727 Cleanup selinux packages dir on uninstall
- Resolves: JWS-681 Change java requirement for tomcat to headless
- Resolves: JWS-968 common-daemon jar symlink contains wrong version in name
- Resolves: JWS-771 tomcat-tool-wrapper is missing tomcat-api.jar on the CLASSPATH
- Resolves: JWS-770 tomcat-digest missing tomcat-api.jar at CLASSPATH

* Wed Apr 11 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-2.redhat_2.1
- Resolves: JWS-599 Tomcat ServerInfo update to reflect redhat version string
- Resolves: JWS-967 jpackage-utils RPM dependency should be updated to use the jws5-javapackages-tools package

* Wed Apr 11 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.7-1.redhat_1.1
- Rebase to Tomcat 9.0.7

* Mon Apr 09 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.6-2.redhat_2.2
- Resolves: JWS-965 tomcat doesn't start via jws5-tomcat service

* Tue Mar 20 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.6-1.redhat_1.1
- Rebase to Tomcat 9.0.6

* Tue Feb 27 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.5-2.redhat_2.2
- Resolves: JWS-822 man page uid and gid mismatch for service accounts
- Resolves: JWS-817 SELinux denies name_bind to jboss_management_port_t for tomcat_t
- Resolves: JWS-818 SELinux denies name_connect to mysql_port_t for tomcat_t
- Resolves: JWS-819 SELinux denies name_connect to mssql_port_t for tomcat_t
- Resolves: JWS-844 Problem to start tomcat with a user whose group has a name different to the user
- Resolves: JWS-845 tomcat-jsvc.service has TOMCAT_USER value hard-coded
- Resolves: JWS-864 tomcat systemd does not cope with - in service names

* Tue Feb 20 2018 Patrick Sutherland <csutherl@redhat.com> - 9.0.5-1.redhat_2.1
- Attempt #2

* Tue Feb 20 2018 Coty Sutherland <csutherl@redhat.com> - 9.0.5.redhat_1.1
- JWS_5.0.0.DR1
